#include <math.h>
#include <stdio.h>
#include <propeller.h>
#include "adc.h"

#define P27 1<<27 
#define P26 1<<26 
#define CRTAMODE (1<<28) + (1<<27) + 27  // DUTY SINGLE ENDED
#define CRTBMODE (1<<28) + (1<<27) + 26  // DUTY SINGLE ENDED

#define	PI		3.14159265358979323846	/* pi */
#define TWOPI 2. * PI
// 2 * pi * f / f_sample
#define W 	(TWOPI * 50.0 / 10000.0) 
#define phi	(W - PI/2.0)

#define _a0 (tan(phi))
#define _a1  (1.0 / cos(phi))

#define TOFIX(d, q) ((int)( (d)*(double)(1<<(q)) ))
#define TOFLT(a, q) ( (double)(a) / (double)(1<<(q)) )
#define q 31

void main ()
{
  double adc,i1,i2,q1,q2,dot,norm1,norm2,res;
  double adc_1;
  int h = 0x80000000 ; 
  int n=0;

  adc_init(21, 20, 19, 18); // CS=21, SCL=20, DO=19, DI=18
  DIRA |= P27; 
  DIRA |= P26;                           
  CTRA = CRTAMODE;
  CTRB = CRTBMODE;    
LOOP:
  adc_1 = 0.0;
  // 0 ... PI/2  
  for(int i = 0; i < 50; i++)
  {
    // IQ Generator for Reference    
    i2 = sin(i*W);
    q2 = -cos(i*W);
    FRQA = h-TOFIX(i2,q); //P27 CH1
    FRQB = TOFIX(q2,q);   //P26 CH2
    
    //adc = q2;
    // Signal Sampling
    adc = (float)adc_in(0)/4096.0;
		///printf("%f %f\n",adc,q2);	  
    
    // Pseudo IQ with Samplesignal    
    i1 = adc;
		q1 = _a0 * adc + _a1 * adc_1;
    adc_1 = adc;
    // Vector Operation
		dot = i1 * i2 + q1 * q2;
		norm1 = sqrt(i1*i1 + q1*q1);
		norm2 = sqrt(i2*i2 + q2*q2);
		res = dot/(norm1 * norm2);
    
  }
		// angle between I2+jQ2 and I1+jQ1
    printf("%f \n",acos(res));
    goto LOOP;
}